/*
 File: wysuwyg_history.js
 Copyright: Rahul Singh
 Mail: induscrypt@gmail.com
 Source: http://wysuwyg.mozdev.org
 Referenced by: wysuwyg_history.xul
 Description: An RDF based repository for usage history
 			Tree based display.		
 			
*/



var wysHistory = {

 MAXHIST:20, //Max num of entries
 HISTFILE:null,
 HISTREE: null,

 dirService: null,
 IOService: null,
 rdfService: null,
 containerUtils: null,
 
 debugenabled:false, //debug mode, passed explicitly by the overlay

 initHisTree: function()
{
 
 	try{

	dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties); 
	IOService= Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
	rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                   getService(Components.interfaces.nsIRDFService);
    containerUtils = Components.classes['@mozilla.org/rdf/container-utils;1']. 
                                 getService(Components.interfaces.nsIRDFContainerUtils);               
                   
	myDir = dirService.get("ProfD", Components.interfaces.nsIFile);
	myDir.append("wysuwyg");
	
	if ( !myDir.exists() )
		{
			myDir.create(myDir.DIRECTORY_TYPE, 0700);
		}
	myDir.append("hist.rdf");	
	if ( !myDir.exists() )
		{
			myDir.create(myDir.NORMAL_FILE_TYPE, 0666);			
			var fileURL = IOService.newFileURI(myDir).spec;	
			var ds = rdfService.GetDataSourceBlocking(fileURL);			
			var newresource=rdfService.GetResource("http://wysuwyg.mozdev.com/all-entries");
			var aSequence = containerUtils.MakeSeq(ds,newresource);			
			ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
			ds.Flush();		
			
		}
	 
	 HISTFILE= IOService.newFileURI(myDir).spec;
	 //build tree
	 
	 
	}catch (ex)	{if(debugenabled) alert("Error initialising wySUwyg history \n " + ex.message);}

},


 openLink : function()
{ 
	
  var htree=HISTREE;
  var indx = htree.currentIndex;
  var url = htree.view.getCellText(indx, htree.columns["url"]);
  window.open(url);
},

showLinkBrHist : function()
{ 
	
  var htree=document.getElementById("histTree");
  var indx = htree.currentIndex;
  var url = htree.view.getCellText(indx, htree.columns["url"]);
  window.open(url); 
 
},


 entDate : function()
{ 
	
  var htree=HISTREE;
  var indx = htree.currentIndex;
  if (indx == -1) return null;
  var dt = htree.view.getCellText(indx, htree.columns["timestamp"]);
  return dt; 
 
},


 saveEntry: function(title,link,dt)
{

	try{


	var ds=rdfService.GetDataSourceBlocking(HISTFILE);
	
	var subject = rdfService.GetResource("http://wysuwyg.mozdev.com/ed-history/"+dt);
	var predicate = rdfService.GetResource("http://wysuwyg.mozdev.com/rdf#title");
	var name = rdfService.GetLiteral(title);
	
	ds.Assert(subject, predicate, name, true);
	
	var predicate1 = rdfService.GetResource("http://wysuwyg.mozdev.com/rdf#url");
	var name1 = rdfService.GetLiteral(link);
	ds.Assert(subject, predicate1, name1, true);
	
	
	var predicate2 = rdfService.GetResource("http://wysuwyg.mozdev.com/rdf#timestamp");
	var name2 = rdfService.GetLiteral(dt);
	ds.Assert(subject, predicate2, name2, true);
	
	//now try adding to list
	
	
	var newresource=rdfService.GetResource("http://wysuwyg.mozdev.com/all-entries");
	
	var aSequence = containerUtils.MakeSeq(ds,newresource);
	
	aSequence.AppendElement(subject);
	
	//remove entries if>max
	
	if (aSequence.GetCount() >= wysHistory.MAXHIST)
	{
	var firstRes= aSequence.RemoveElementAt ( 1,true );
	//var d=firstRes.get
	wysHistory.removeResource  ( ds, firstRes);
	
	}
	
	ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	ds.Flush();	
	
	//htree.builder.rebuild( );
	
	} catch(ex) { }

},





 removeEntry: function(dt)
{
	
	try{
	var ds=rdfService.GetDataSourceBlocking(HISTFILE);
	
	//find what contains this date
	
	var subject = rdfService.GetResource("http://wysuwyg.mozdev.com/ed-history/"+dt);
	var newresource=rdfService.GetResource("http://wysuwyg.mozdev.com/all-entries");
	
	var aSequence = containerUtils.MakeSeq(ds,newresource);
	aSequence.RemoveElement(subject,true);
	ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	wysHistory.removeResource  ( ds, subject);
	ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	ds.Flush();
	
	//var htree=HISTREE;
	//htree.builder.rebuild( );
	} catch(ex) { }
},



//remove one resource from RDF root
removeResource: function  ( datasource, res)
	{
		var names = datasource.ArcLabelsOut(res);
		
		while ( names.hasMoreElements() )
		{
			//try {
				var name  = names.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
				var value = datasource.GetTarget(res, name, true);
				datasource.Unassert(res, name, value);
			//} catch(ex) {
			//}
		}
		
	},

//build tree if opened from the (displayed) wysuwyg_history.xul
updateHistree: function(tr)
{

	 HISTREE=tr;
	 var ds=rdfService.GetDataSource(HISTFILE);
	 HISTREE.database.AddDataSource(ds);
	 HISTREE.builder.rebuild( );

}


}//end class

var wyshist=null;

function startHist(tr,debugflag)
{
  wysHistory.initHisTree();
  if(tr!= null)
  {
  wysHistory.updateHistree(tr);
  
  }

}
